angular.module('starter.controllers', [])

.controller('TodayCtrl', function($scope, Tasks) {
    $scope.task = {
      data: ''
    };
    $scope.dailyTasks = [];
    $scope.dailyTasks = Tasks.all();

    $scope.isToday = function (task) {
      return Tasks.isToday(task); 
    };

    $scope.reminder = function (task, event) {
        var options = {
          date: new Date(),
          mode: 'time', // or 'time'
          minDate: new Date(),
          allowOldDates: false,
          allowFutureDates: false,
          doneButtonLabel: 'DONE',
          doneButtonColor: '#F2F3F4',
          cancelButtonLabel: 'CANCEL',
          cancelButtonColor: '#000000'
        };
      datePicker.show(options, function(date){
           if(typeof date == "undefined") {
            return;
          }
          window.plugin.notification.local.add({
                id:      task.id,
                title:   task.task,
                message: 'Daily Task Tracker',
                date:    date,
                autoCancel: true
          });
      });
      return true;
    };

    $scope.addTask = function() {

        if($scope.task.data == undefined || $scope.task.data == "") {
        } else {
            var task = {};

            task = {
              id: new Date().getTime(),
              task: $scope.task.data,
              curr_date: new Date(),
              status: 0
            };

            
            $scope.dailyTasks.push(task);

            Tasks.update($scope.dailyTasks);
            $scope.task.data = '';
        }
    };

    $scope.done = function(task, e){
        e.stopPropagation();
        task.status = 1;
        task.finisheddate = new Date();
        Tasks.update($scope.dailyTasks);
        window.plugin.notification.local.cancel(task.id);
    }

    $scope.deleteTask = function(index, e){
        e.stopPropagation();
        var task = $scope.dailyTasks[index];
        $scope.dailyTasks.splice(index, 1);
        Tasks.update($scope.dailyTasks);
        
        window.plugin.notification.local.cancel(task.id);
    }
        
      
})
.controller('FinishedCtrl', function($scope, Tasks, $rootScope) {
     $rootScope.$on( "$ionicView.enter", function( scopes, states ) {
          if( states.stateName == "tab.finished" ) {
              $scope.dailyTasks = [];
              $scope.dailyTasks = Tasks.all();

                $scope.isToday = function (task) {
                  return Tasks.isToday(task); 
                };
          }
      });
})
.controller('HistoryCtrl', function($scope, Tasks, $rootScope) {
    $rootScope.$on( "$ionicView.enter", function( scopes, states ) {
          if( states.fromCache && states.stateName == "tab.history" ) {
              $scope.dailyTasks = [];
              $scope.dailyTasks = Tasks.all();
                removeOldTask();

                $scope.isToday = function (task) {
                  return Tasks.isToday(task); 
                };
          }
      });

      
      function removeOldTask () {
        var selectedTimestamp = new Date().getTime();

        angular.forEach($scope.dailyTasks, function (d, index) {
          var curr_date = new Date(d.curr_date)
          curr_date.setDate(curr_date.getDate() + 7);
          var timestamp = curr_date.getTime();
          if(timestamp < selectedTimestamp) {
               $scope.dailyTasks.splice(index, 1);
          }
        });
        Tasks.update($scope.dailyTasks);
      }
});
