angular.module('starter.services', [])
.factory('Tasks', function($localstorage) {

  Date.prototype.sameDay = function(d) {
      return this.getFullYear() === d.getFullYear()
        && this.getDate() === d.getDate()
        && this.getMonth() === d.getMonth();
  }

  return {
    all: function() {
      return $localstorage.getObject();
    },
    update: function(value) {
        $localstorage.setObject(value);
    },
    isToday: function (task) {
      var date = new Date(task.curr_date);
      
      return new Date().sameDay(date);
    },
    setToast: function() {
       $localstorage.setToast();
    }, 
    getToast: function() {
       return $localstorage.getToast();
    }
  }
})
.factory('$localstorage', ['$window', function($window) {
  var key = 'taskList';
  return {
    setObject: function(value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function() {
      if($window.localStorage[key]) {
        return JSON.parse($window.localStorage[key]);  
      } else {
        return [];  
      }
    },
    setToast: function() {
      if($window.localStorage['dtt-count']) {
        $window.localStorage['dtt-count'] += 1;
      } else {
        $window.localStorage['dtt-count'] = 1;
      }
      if($window.localStorage['dtt-count'] == 11111) {
        $window.localStorage['dtt-toast'] = true;  
      }
      
    }, 
    getToast: function() {
      if($window.localStorage['dtt-toast']) {
        return $window.localStorage['dtt-toast'];  
      } else {
        return false;  
      }
    }
  }
}])
.directive('ngEnter', function () {
      return function (scope, element, attrs) {
          element.bind("keydown keypress", function (event) {

            if(event.which === 13) {
                scope.$apply(function (){
                    scope.$eval(attrs.ngEnter);
                });
                event.preventDefault();
            }
          });
      };
  });
